#!../util/python/bin/python

import sys
from os import environ

try:
     syb=environ["SYBASE"]
except:
     print "ERROR: SYBASE environment empty. Needed by the Sybase module."
     sys.exit(1)
else:
     print "SYBASE=%s" % syb

try:
     lang=environ["LANG"]
except:
     pass
else:
     print "ERROR: LANG variable defined. It could conflict with the Sybase module."
     print "Remove it before running this script."
     sys.exit(1)

modules=["Numeric", "mx", "numarray", "sybasect", "Sybase","Qfits","qfits","pcfitsio", "fitsio", "gdbm", "_bsddb", "bsddb3", "zlib", "pcc", "socket" , "httplib", "sqlite3", "_md5", "_sha", "_sha256", "_sha512" ]

for mod in modules:
     try:
        exec ("import %s" % mod)
     except ImportError, msg:
        print "Fail importing %s module: %s" % (mod, msg)
     else:
        print "Succeeding importing %s module" % mod

if not hasattr( socket, "ssl" ):
  print "ERROR: socket module has no ssl support!"
else:
  print "socket module has ssl support"

if not hasattr( httplib, "HTTPS" ):
  print "ERROR: httplib module has no HTTPS support!" 
else:
  print "httplib module has HTTPS support" 

print "Testing Sybase Connection"
con = Sybase.connect("DEV15SRV", "ngas", "ngas_pw", delay_connect = 1)
con.set_property(Sybase.CS_HOSTNAME, "hostname")
con.set_property(Sybase.CS_APPNAME, "test-app")
con.connect()

try:
 exec ("con.execute(\"use ngastst2\")")
except ImportError, msg:
  print "Fail Sybase Connection with DEVSRV:use ngastst2"
else:
  print "Connection succeeded"

sys.exit(0)

